!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2010.  Los Alamos National Security, LLC. This material was    !
! produced under U.S. Government contract DE-AC52-06NA25396 for Los Alamos !
! National Laboratory (LANL), which is operated by Los Alamos National     !
! Security, LLC for the U.S. Department of Energy. The U.S. Government has !
! rights to use, reproduce, and distribute this software.  NEITHER THE     !
! GOVERNMENT NOR LOS ALAMOS NATIONAL SECURITY, LLC MAKES ANY WARRANTY,     !
! EXPRESS OR IMPLIED, OR ASSUMES ANY LIABILITY FOR THE USE OF THIS         !
! SOFTWARE.  If software is modified to produce derivative works, such     !
! modified software should be clearly marked, so as not to confuse it      !
! with the version available from LANL.                                    !
!                                                                          !
! Additionally, this program is free software; you can redistribute it     !
! and/or modify it under the terms of the GNU General Public License as    !
! published by the Free Software Foundation; version 2.0 of the License.   !
! Accordingly, this program is distributed in the hope that it will be     !
! useful, but WITHOUT ANY WARRANTY; without even the implied warranty of   !
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General !
! Public License for more details.                                         !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

SUBROUTINE READRESTARTLIB(ITER)

  USE CONSTANTS_MOD
  USE KSPACEARRAY
  USE NEBLISTARRAY
  USE PPOTARRAY
  USE RESTARTARRAY
  USE SPARSEARRAY
  USE UNIVARRAY
  USE XBOARRAY
  USE COULOMBARRAY
  USE DIAGARRAY
  USE MDARRAY
  USE NONOARRAY
  USE PUREARRAY
  USE SETUPARRAY
  USE SPINARRAY
  USE VIRIALARRAY
#ifdef MPI_ON
  USE MPI
#endif

  IMPLICIT NONE

  INTEGER :: I, K, ITER
  INTEGER :: MYID, IERR, DUMMYN, DUMMYN1, DUMMYN2
  INTEGER :: CHARACTERCHECK(9),COMPLEXCHECK(15),INTEGERCHECK(20),REALCHECK(99)
  INTEGER :: CHECK(25)
  REAL(LATTEPREC) :: TMP1, TMP2
  REAL(LATTEPREC), ALLOCATABLE :: TMPBODIAGUP(:), TMPBODIAGDOWN(:)
  COMPLEX(LATTEPREC) :: KSUM
  CHARACTER(LEN=100) :: FLNM, NAME
  IF (EXISTERROR) RETURN

  IF (VERBOSE >= 1) write(*,*) "Restarting latte_lib from file ..."

  OPEN(14,FILE="restart.latte.dat",FORM="UNFORMATTED",STATUS="OLD")

  READ(14)CHARACTERCHECK
  READ(14)COMPLEXCHECK
  READ(14)INTEGERCHECK
  READ(14)REALCHECK

  READ(14)ITER

  write(*,*)"ITER",ITER
  LIBCALLS = ITER

  IF(CHARACTERCHECK( 2 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ATELE )) ALLOCATE( ATELE (DUMMYN))
     READ(14) ATELE
  ENDIF

  IF(CHARACTERCHECK( 3 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( BASIS )) ALLOCATE( BASIS (DUMMYN))
     READ(14) BASIS
  ENDIF

  IF(CHARACTERCHECK( 4 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( BTYPE )) ALLOCATE( BTYPE (DUMMYN))
     READ(14) BTYPE
  ENDIF

  IF(CHARACTERCHECK( 5 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ELE )) ALLOCATE( ELE (DUMMYN))
     READ(14) ELE
  ENDIF

  IF(CHARACTERCHECK( 6 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ELE1 )) ALLOCATE( ELE1 (DUMMYN))
     READ(14) ELE1
  ENDIF

  IF(CHARACTERCHECK( 7 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ELE2 )) ALLOCATE( ELE2 (DUMMYN))
     READ(14) ELE2
  ENDIF

  IF(CHARACTERCHECK( 8 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( PPELE1 )) ALLOCATE( PPELE1 (DUMMYN))
     READ(14) PPELE1
  ENDIF

  IF(CHARACTERCHECK( 9 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( PPELE2 )) ALLOCATE( PPELE2 (DUMMYN))
     READ(14) PPELE2
  ENDIF

  IF(COMPLEXCHECK( 2 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( DIAG_ZWORK )) ALLOCATE( DIAG_ZWORK (DUMMYN))
     READ(14) DIAG_ZWORK
  ENDIF

  IF(COMPLEXCHECK( 3 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(.NOT.ALLOCATED( HK )) ALLOCATE( HK (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) HK
  ENDIF

  IF(COMPLEXCHECK( 4 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(.NOT.ALLOCATED( HK0 )) ALLOCATE( HK0 (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) HK0
  ENDIF

  IF(COMPLEXCHECK( 5 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( HKDIAG )) ALLOCATE( HKDIAG (DUMMYN,DUMMYN1))
     READ(14) HKDIAG
  ENDIF

  IF(COMPLEXCHECK( 6 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(.NOT.ALLOCATED( KBO )) ALLOCATE( KBO (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) KBO
  ENDIF

  IF(COMPLEXCHECK( 7 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(.NOT.ALLOCATED( KEVECS )) ALLOCATE( KEVECS (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) KEVECS
  ENDIF

  IF(COMPLEXCHECK( 8 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( KF )) ALLOCATE( KF (DUMMYN,DUMMYN1))
     READ(14) KF
  ENDIF

  IF(COMPLEXCHECK( 9 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( KHTMP )) ALLOCATE( KHTMP (DUMMYN,DUMMYN1))
     READ(14) KHTMP
  ENDIF

  IF(COMPLEXCHECK( 10 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(.NOT.ALLOCATED( KORTHOH )) ALLOCATE( KORTHOH (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) KORTHOH
  ENDIF

  IF(COMPLEXCHECK( 11 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(.NOT.ALLOCATED( KXMAT )) ALLOCATE( KXMAT (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) KXMAT
  ENDIF

  IF(COMPLEXCHECK( 12 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(.NOT.ALLOCATED( SK )) ALLOCATE( SK (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) SK
  ENDIF

  IF(COMPLEXCHECK( 13 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( ZBO )) ALLOCATE( ZBO (DUMMYN,DUMMYN1))
     READ(14) ZBO
  ENDIF

  IF(COMPLEXCHECK( 14 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ZHEEVD_WORK )) ALLOCATE( ZHEEVD_WORK (DUMMYN))
     READ(14) ZHEEVD_WORK
  ENDIF

  IF(COMPLEXCHECK( 15 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ZHJJ )) ALLOCATE( ZHJJ (DUMMYN))
     READ(14) ZHJJ
  ENDIF

  IF(INTEGERCHECK( 2 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( DIAG_IWORK )) ALLOCATE( DIAG_IWORK (DUMMYN))
     READ(14) DIAG_IWORK
  ENDIF

  IF(INTEGERCHECK( 3 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ELEMPOINTER )) ALLOCATE( ELEMPOINTER (DUMMYN))
     READ(14) ELEMPOINTER
  ENDIF

  IF(INTEGERCHECK( 4 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( IFAIL )) ALLOCATE( IFAIL (DUMMYN))
     READ(14) IFAIL
  ENDIF

  IF(INTEGERCHECK( 5 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( MATINDLIST )) ALLOCATE( MATINDLIST (DUMMYN))
     READ(14) MATINDLIST
  ENDIF

  IF(INTEGERCHECK( 6 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( MOLID )) ALLOCATE( MOLID (DUMMYN))
     READ(14) MOLID
  ENDIF

  IF(INTEGERCHECK( 7 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(ALLOCATED( NEBCOUL )) DEALLOCATE(NEBCOUL)
     ALLOCATE( NEBCOUL (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) NEBCOUL
  ENDIF

  IF(INTEGERCHECK( 8 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(ALLOCATED( NEBPP )) DEALLOCATE( NEBPP )
     ALLOCATE( NEBPP (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) NEBPP
  ENDIF

  IF(INTEGERCHECK( 9 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1 ,DUMMYN2
     IF(ALLOCATED( NEBTB )) DEALLOCATE( NEBTB )
     ALLOCATE( NEBTB (DUMMYN,DUMMYN1,DUMMYN2))
     READ(14) NEBTB
  ENDIF

  IF(INTEGERCHECK( 10 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( NONO_IWORK )) ALLOCATE( NONO_IWORK (DUMMYN))
     READ(14) NONO_IWORK
  ENDIF

  IF(INTEGERCHECK( 11 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( PPTABLENGTH )) ALLOCATE( PPTABLENGTH (DUMMYN))
     READ(14) PPTABLENGTH
  ENDIF

  IF(INTEGERCHECK( 12 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( RX )) ALLOCATE( RX (DUMMYN))
     READ(14) RX
  ENDIF

  IF(INTEGERCHECK( 13 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( RXTMP )) ALLOCATE( RXTMP (DUMMYN))
     READ(14) RXTMP
  ENDIF

  IF(INTEGERCHECK( 14 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( SIGNLIST )) ALLOCATE( SIGNLIST (DUMMYN))
     READ(14) SIGNLIST
  ENDIF

  IF(INTEGERCHECK( 15 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( SPININDLIST )) ALLOCATE( SPININDLIST (DUMMYN))
     READ(14) SPININDLIST
  ENDIF

  IF(INTEGERCHECK( 16 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( TOTNEBCOUL )) ALLOCATE( TOTNEBCOUL (DUMMYN))
     READ(14) TOTNEBCOUL
  ENDIF

  IF(INTEGERCHECK( 17 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( TOTNEBPP )) ALLOCATE( TOTNEBPP (DUMMYN))
     READ(14) TOTNEBPP
  ENDIF

  IF(INTEGERCHECK( 18 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( TOTNEBTB )) ALLOCATE( TOTNEBTB (DUMMYN))
     READ(14) TOTNEBTB
  ENDIF

  IF(INTEGERCHECK( 19 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( XB )) ALLOCATE( XB (DUMMYN))
     READ(14) XB
  ENDIF

  IF(INTEGERCHECK( 20 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ZHEEVD_IWORK )) ALLOCATE( ZHEEVD_IWORK (DUMMYN))
     READ(14) ZHEEVD_IWORK
  ENDIF

  IF(REALCHECK( 2 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ATOCC )) ALLOCATE( ATOCC (DUMMYN))
     READ(14) ATOCC
  ENDIF

  IF(REALCHECK( 3 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( BO )) ALLOCATE( BO (DUMMYN,DUMMYN1))
     READ(14) BO
  ENDIF

  IF(REALCHECK( 4 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( BOND )) ALLOCATE( BOND (DUMMYN,DUMMYN1))
     READ(14) BOND
  ENDIF

  IF(REALCHECK( 5 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( BOZERO )) ALLOCATE( BOZERO (DUMMYN))
     READ(14) BOZERO
  ENDIF

  IF(REALCHECK( 6 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( BO_PADDED )) ALLOCATE( BO_PADDED (DUMMYN,DUMMYN1))
     READ(14) BO_PADDED
  ENDIF

  IF(REALCHECK( 7 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( CHEMPOT_PNK )) ALLOCATE( CHEMPOT_PNK (DUMMYN))
     READ(14) CHEMPOT_PNK
  ENDIF

  IF(REALCHECK( 8 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( COSLIST )) ALLOCATE( COSLIST (DUMMYN))
     READ(14) COSLIST
  ENDIF

  IF(REALCHECK( 9 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( COULOMBV )) ALLOCATE( COULOMBV (DUMMYN))
     READ(14) COULOMBV
  ENDIF

  IF(REALCHECK( 10 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( CPLIST )) ALLOCATE( CPLIST (DUMMYN))
     READ(14) CPLIST
  ENDIF

  IF(REALCHECK( 11 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( CR )) ALLOCATE( CR (DUMMYN,DUMMYN1))
     READ(14) CR
  ENDIF

  IF(REALCHECK( 12 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( DELTAQ )) ALLOCATE( DELTAQ (DUMMYN))
     READ(14) DELTAQ
  ENDIF

  IF(REALCHECK( 13 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( DELTASPIN )) ALLOCATE( DELTASPIN (DUMMYN))
     READ(14) DELTASPIN
  ENDIF

  IF(REALCHECK( 14 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( DIAG_RWORK )) ALLOCATE( DIAG_RWORK (DUMMYN))
     READ(14) DIAG_RWORK
  ENDIF

  IF(REALCHECK( 15 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( DIAG_WORK )) ALLOCATE( DIAG_WORK (DUMMYN))
     READ(14) DIAG_WORK
  ENDIF

  IF(REALCHECK( 16 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( DOWNEVALS )) ALLOCATE( DOWNEVALS (DUMMYN))
     READ(14) DOWNEVALS
  ENDIF

  IF(REALCHECK( 17 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( DOWNEVECS )) ALLOCATE( DOWNEVECS (DUMMYN,DUMMYN1))
     READ(14) DOWNEVECS
  ENDIF

  IF(REALCHECK( 18 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( EHIST )) ALLOCATE( EHIST (DUMMYN))
     READ(14) EHIST
  ENDIF

  IF(REALCHECK( 19 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( EVALS )) ALLOCATE( EVALS (DUMMYN))
     READ(14) EVALS
  ENDIF

  IF(REALCHECK( 20 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( EVECS )) ALLOCATE( EVECS (DUMMYN,DUMMYN1))
     READ(14) EVECS
  ENDIF

  IF(REALCHECK( 21 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( F )) ALLOCATE( F (DUMMYN,DUMMYN1))
     READ(14) F
  ENDIF

  IF(REALCHECK( 22 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( FCOUL )) ALLOCATE( FCOUL (DUMMYN,DUMMYN1))
     READ(14) FCOUL
  ENDIF

  IF(REALCHECK( 23 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( FPP )) ALLOCATE( FPP (DUMMYN,DUMMYN1))
     READ(14) FPP
  ENDIF

  IF(REALCHECK( 24 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( FPUL )) ALLOCATE( FPUL (DUMMYN,DUMMYN1))
     READ(14) FPUL
  ENDIF

  IF(REALCHECK( 25 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( FRANPREV )) ALLOCATE( FRANPREV (DUMMYN,DUMMYN1))
     READ(14) FRANPREV
  ENDIF

  IF(REALCHECK( 26 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( FSCOUL )) ALLOCATE( FSCOUL (DUMMYN,DUMMYN1))
     READ(14) FSCOUL
  ENDIF

  IF(REALCHECK( 27 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( FSSPIN )) ALLOCATE( FSSPIN (DUMMYN,DUMMYN1))
     READ(14) FSSPIN
  ENDIF

  IF(REALCHECK( 28 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( FTOT )) ALLOCATE( FTOT (DUMMYN,DUMMYN1))
     READ(14) FTOT
  ENDIF

  IF(REALCHECK( 29 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( H )) ALLOCATE( H (DUMMYN,DUMMYN1))
     READ(14) H
  ENDIF

  IF(REALCHECK( 30 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( H0 )) ALLOCATE( H0 (DUMMYN,DUMMYN1))
     READ(14) H0
  ENDIF

  IF(REALCHECK( 31 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( H2VECT )) ALLOCATE( H2VECT (DUMMYN))
     READ(14) H2VECT
  ENDIF

  IF(REALCHECK( 32 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( HDIAG )) ALLOCATE( HDIAG (DUMMYN))
     READ(14) HDIAG
  ENDIF

  IF(REALCHECK( 33 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( HDOWN )) ALLOCATE( HDOWN (DUMMYN,DUMMYN1))
     READ(14) HDOWN
  ENDIF

  IF(REALCHECK( 34 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( HED )) ALLOCATE( HED (DUMMYN))
     READ(14) HED
  ENDIF

  IF(REALCHECK( 35 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( HEF )) ALLOCATE( HEF (DUMMYN))
     READ(14) HEF
  ENDIF

  IF(REALCHECK( 36 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( HEP )) ALLOCATE( HEP (DUMMYN))
     READ(14) HEP
  ENDIF

  IF(REALCHECK( 37 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( HES )) ALLOCATE( HES (DUMMYN))
     READ(14) HES
  ENDIF

  IF(REALCHECK( 38 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( HJJ )) ALLOCATE( HJJ (DUMMYN))
     READ(14) HJJ
  ENDIF

  IF(REALCHECK( 39 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( HR0 )) ALLOCATE( HR0 (DUMMYN))
     READ(14) HR0
  ENDIF

  IF(REALCHECK( 40 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( HUBBARDU )) ALLOCATE( HUBBARDU (DUMMYN))
     READ(14) HUBBARDU
  ENDIF

  IF(REALCHECK( 41 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( HUP )) ALLOCATE( HUP (DUMMYN,DUMMYN1))
     READ(14) HUP
  ENDIF

  IF(REALCHECK( 42 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( KEVALS )) ALLOCATE( KEVALS (DUMMYN,DUMMYN1))
     READ(14) KEVALS
  ENDIF

  IF(REALCHECK( 43 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( LCNSHIFT )) ALLOCATE( LCNSHIFT (DUMMYN))
     READ(14) LCNSHIFT
  ENDIF

  IF(REALCHECK( 44 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( MASS )) ALLOCATE( MASS (DUMMYN))
     READ(14) MASS
  ENDIF

  IF(REALCHECK( 45 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( MYCHARGE )) ALLOCATE( MYCHARGE (DUMMYN))
     READ(14) MYCHARGE
  ENDIF

  IF(REALCHECK( 46 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( NONOTMP )) ALLOCATE( NONOTMP (DUMMYN,DUMMYN1))
     READ(14) NONOTMP
  ENDIF

  IF(REALCHECK( 47 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( NONO_EVALS )) ALLOCATE( NONO_EVALS (DUMMYN))
     READ(14) NONO_EVALS
  ENDIF

  IF(REALCHECK( 48 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( NONO_WORK )) ALLOCATE( NONO_WORK (DUMMYN))
     READ(14) NONO_WORK
  ENDIF

  IF(REALCHECK( 49 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( OLDDELTAQS )) ALLOCATE( OLDDELTAQS (DUMMYN))
     READ(14) OLDDELTAQS
  ENDIF

  IF(REALCHECK( 50 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( OLDDELTASPIN )) ALLOCATE( OLDDELTASPIN (DUMMYN))
     READ(14) OLDDELTASPIN
  ENDIF

  IF(REALCHECK( 51 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( ORTHOH )) ALLOCATE( ORTHOH (DUMMYN,DUMMYN1))
     READ(14) ORTHOH
  ENDIF

  IF(REALCHECK( 52 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( ORTHOHDOWN )) ALLOCATE( ORTHOHDOWN (DUMMYN,DUMMYN1))
     READ(14) ORTHOHDOWN
  ENDIF

  IF(REALCHECK( 53 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( ORTHOHUP )) ALLOCATE( ORTHOHUP (DUMMYN,DUMMYN1))
     READ(14) ORTHOHUP
  ENDIF

  IF(REALCHECK( 54 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( ORTHORHO )) ALLOCATE( ORTHORHO (DUMMYN,DUMMYN1))
     READ(14) ORTHORHO
  ENDIF

  IF(REALCHECK( 55 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( OVERL )) ALLOCATE( OVERL (DUMMYN,DUMMYN1))
     READ(14) OVERL
  ENDIF

  IF(REALCHECK( 56 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( PAIR )) ALLOCATE( PAIR (DUMMYN,DUMMYN1))
     READ(14) PAIR
  ENDIF

  IF(REALCHECK( 57 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( PHIST )) ALLOCATE( PHIST (DUMMYN))
     READ(14) PHIST
  ENDIF

  IF(REALCHECK( 58 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( PHISTX )) ALLOCATE( PHISTX (DUMMYN))
     READ(14) PHISTX
  ENDIF

  IF(REALCHECK( 59 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( PHISTY )) ALLOCATE( PHISTY (DUMMYN))
     READ(14) PHISTY
  ENDIF

  IF(REALCHECK( 60 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( PHISTZ )) ALLOCATE( PHISTZ (DUMMYN))
     READ(14) PHISTZ
  ENDIF

  IF(REALCHECK( 61 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( PNK )) ALLOCATE( PNK (DUMMYN,DUMMYN1))
     READ(14) PNK
  ENDIF

  IF(REALCHECK( 62 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( POTCOEF )) ALLOCATE( POTCOEF (DUMMYN,DUMMYN1))
     READ(14) POTCOEF
  ENDIF

  IF(REALCHECK( 63 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( PPR )) ALLOCATE( PPR (DUMMYN,DUMMYN1))
     READ(14) PPR
  ENDIF

  IF(REALCHECK( 64 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( PPSPL )) ALLOCATE( PPSPL (DUMMYN,DUMMYN1))
     READ(14) PPSPL
  ENDIF

  IF(REALCHECK( 65 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( PPVAL )) ALLOCATE( PPVAL (DUMMYN,DUMMYN1))
     READ(14) PPVAL
  ENDIF

  IF(REALCHECK( 66 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( QLIST )) ALLOCATE( QLIST (DUMMYN))
     READ(14) QLIST
  ENDIF

  IF(REALCHECK( 67 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( RESPCHI )) ALLOCATE( RESPCHI (DUMMYN))
     READ(14) RESPCHI
  ENDIF

  IF(REALCHECK( 68 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( RHODOWN )) ALLOCATE( RHODOWN (DUMMYN,DUMMYN1))
     READ(14) RHODOWN
  ENDIF

  IF(REALCHECK( 69 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( RHODOWNZERO )) ALLOCATE( RHODOWNZERO (DUMMYN))
     READ(14) RHODOWNZERO
  ENDIF

  IF(REALCHECK( 70 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( RHOUP )) ALLOCATE( RHOUP (DUMMYN,DUMMYN1))
     READ(14) RHOUP
  ENDIF

  IF(REALCHECK( 71 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( RHOUPZERO )) ALLOCATE( RHOUPZERO (DUMMYN))
     READ(14) RHOUPZERO
  ENDIF

  IF(REALCHECK( 72 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( SH2 )) ALLOCATE( SH2 (DUMMYN,DUMMYN1))
     READ(14) SH2
  ENDIF

  IF(REALCHECK( 73 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( SINLIST )) ALLOCATE( SINLIST (DUMMYN))
     READ(14) SINLIST
  ENDIF

  IF(REALCHECK( 74 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( SMAT )) ALLOCATE( SMAT (DUMMYN,DUMMYN1))
     READ(14) SMAT
  ENDIF

  IF(REALCHECK( 75 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( SPINLIST )) ALLOCATE( SPINLIST (DUMMYN))
     READ(14) SPINLIST
  ENDIF

  IF(REALCHECK( 76 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( SPINTMP )) ALLOCATE( SPINTMP (DUMMYN,DUMMYN1))
     READ(14) SPINTMP
  ENDIF

  IF(REALCHECK( 77 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( SPIN_PNK )) ALLOCATE( SPIN_PNK (DUMMYN,DUMMYN1))
     READ(14) SPIN_PNK
  ENDIF

  IF(REALCHECK( 78 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( THIST )) ALLOCATE( THIST (DUMMYN))
     READ(14) THIST
  ENDIF

  IF(REALCHECK( 79 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( TMPBODIAG )) ALLOCATE( TMPBODIAG (DUMMYN))
     READ(14) TMPBODIAG
  ENDIF

  IF(REALCHECK( 80 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( TMPRHODOWN )) ALLOCATE( TMPRHODOWN (DUMMYN))
     READ(14) TMPRHODOWN
  ENDIF

  IF(REALCHECK( 81 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( TMPRHOUP )) ALLOCATE( TMPRHOUP (DUMMYN))
     READ(14) TMPRHOUP
  ENDIF

  IF(REALCHECK( 82 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( TWOXX2 )) ALLOCATE( TWOXX2 (DUMMYN,DUMMYN1))
     READ(14) TWOXX2
  ENDIF

  IF(REALCHECK( 83 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( UMAT )) ALLOCATE( UMAT (DUMMYN,DUMMYN1))
     READ(14) UMAT
  ENDIF

  IF(REALCHECK( 84 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( UPEVALS )) ALLOCATE( UPEVALS (DUMMYN))
     READ(14) UPEVALS
  ENDIF

  IF(REALCHECK( 85 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( UPEVECS )) ALLOCATE( UPEVECS (DUMMYN,DUMMYN1))
     READ(14) UPEVECS
  ENDIF

  IF(REALCHECK( 86 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( V )) ALLOCATE( V (DUMMYN,DUMMYN1))
     READ(14) V
  ENDIF

  IF(REALCHECK( 87 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( VHIST )) ALLOCATE( VHIST (DUMMYN))
     READ(14) VHIST
  ENDIF

  IF(REALCHECK( 88 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( WDD )) ALLOCATE( WDD (DUMMYN))
     READ(14) WDD
  ENDIF

  IF(REALCHECK( 89 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( WFF )) ALLOCATE( WFF (DUMMYN))
     READ(14) WFF
  ENDIF

  IF(REALCHECK( 90 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( WORK )) ALLOCATE( WORK (DUMMYN))
     READ(14) WORK
  ENDIF

  IF(REALCHECK( 91 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( WPP )) ALLOCATE( WPP (DUMMYN))
     READ(14) WPP
  ENDIF

  IF(REALCHECK( 92 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( WSS )) ALLOCATE( WSS (DUMMYN))
     READ(14) WSS
  ENDIF

  IF(REALCHECK( 93 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( X2 )) ALLOCATE( X2 (DUMMYN,DUMMYN1))
     READ(14) X2
  ENDIF

  IF(REALCHECK( 94 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( X2DOWN )) ALLOCATE( X2DOWN (DUMMYN,DUMMYN1))
     READ(14) X2DOWN
  ENDIF

  IF(REALCHECK( 95 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( X2HRHO )) ALLOCATE( X2HRHO (DUMMYN,DUMMYN1))
     READ(14) X2HRHO
  ENDIF

  IF(REALCHECK( 96 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( X2UP )) ALLOCATE( X2UP (DUMMYN,DUMMYN1))
     READ(14) X2UP
  ENDIF

  IF(REALCHECK( 97 ) == 1)THEN
     READ(14) DUMMYN ,DUMMYN1
     IF(.NOT.ALLOCATED( XMAT )) ALLOCATE( XMAT (DUMMYN,DUMMYN1))
     READ(14) XMAT
  ENDIF

  IF(REALCHECK( 98 ) == 1)THEN
     READ(14) DUMMYN
     IF(.NOT.ALLOCATED( ZHEEVD_RWORK )) ALLOCATE( ZHEEVD_RWORK (DUMMYN))
     READ(14) ZHEEVD_RWORK
  ENDIF

  IF(REALCHECK( 99 ) == 1)THEN
     READ(14) DUMMYN, DUMMYN1
     IF(.NOT.ALLOCATED( FSLCN )) ALLOCATE( FSLCN (DUMMYN,DUMMYN1))
     READ(14) FSLCN
  ENDIF
  
  CLOSE(14)

END SUBROUTINE READRESTARTLIB
